<?php
class pkg_tax_europeInstallerScript {
	function preflight($type, $parent){
		$version = explode('.',PHP_VERSION);
		if(!defined('DS'))
			define('DS', DIRECTORY_SEPARATOR);
		$hikashopFile = rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php';
		if(!file_exists($hikashopFile)) {
			echo '<html><body><h1>This Tax package can only be installed for HikaShop.</h1>'.
					'<h2>Please install HikaShop (starter, essential or business) before installing this package.</h2>'.
					'installation abort...</body></html>';
			exit;
		}
		include_once($hikashopFile);

		/*
		* Create records for all EU Countries + their local VAT Tax Rates per 1 January 2015
		*/
		$this->_query("
INSERT IGNORE INTO `#__hikashop_tax` (`tax_namekey`, `tax_rate`) VALUES
('VAT (AT)', 0.20000),
('VAT (BE)', 0.21000),
('VAT (BG)', 0.20000),
('VAT (CY)', 0.19000),
('VAT (CZ)', 0.21000),
('VAT (HR)', 0.25000),
('VAT (DK)', 0.25000),
('VAT (EE)', 0.20000),
('VAT (FI)', 0.24000),
('VAT (FR)', 0.20000),
('VAT (DE)', 0.19000),
('VAT (GR)', 0.23000),
('VAT (HU)', 0.27000),
('VAT (IE)', 0.23000),
('VAT (IT)', 0.22000),
('VAT (LV)', 0.21000),
('VAT (LT)', 0.21000),
('VAT (LU)', 0.15000),
('VAT (MT)', 0.18000),
('VAT (NL)', 0.21000),
('VAT (PL)', 0.23000),
('VAT (PT)', 0.23000),
('VAT (RO)', 0.24000),
('VAT (SK)', 0.20000),
('VAT (SI)', 0.22000),
('VAT (ES)', 0.21000),
('VAT (SE)', 0.25000),
('VAT (GB)', 0.20000),
('VAT Exempt', 0.00000);");

		/*
		* Create new Tax Category for electronic goods and services

		*/
		$this->_query("
INSERT IGNORE INTO `#__hikashop_category` (`category_id`, `category_parent_id`, `category_type`,
`category_name`, `category_description`, `category_published`, `category_ordering`,
`category_left`, `category_right`, `category_depth`, `category_namekey`) VALUES
(0, 3, 'tax', 'Electronic goods & services', '<p>Until January 1st 2015, within the EU the&nbsp;VAT on
e-services (like telecommunications, radio &amp; television broadcasting and electronic services)
to consumers (and businesses without VAT number) is charged based on the location (EU country) of
the seller. <br /> <br />Starting on January 1st 2015, the VAT on e-services to consumers within
the EU must be calculated based on the end customer’s location (address on invoice).<br />
<br />See <a href=\"http://ec.europa.eu/taxation_customs/taxation/vat/traders/e-commerce/index_en.htm\">
http://ec.europa.eu/taxation_customs/taxation/vat/traders/e-commerce/index_en.htm</a>
</p>', 1, 2, 7, 8, 2, 'tax_eservices');");

		/*
		* Create new Taxation rules for all EU countries for "eservice" products.

		Digital goods and services that are sold to:
		- customers in EU countries are taxed on the rate of the customer's country
		- businesses *without* VAT number in EU countries are taxed on the rate of the business's country
		- businesses *with* VAT number in EU countries will be taxed under "VAT Exempt"

		Note: Selling digital goods or services to customers and businesses in your own country
		should be taxed on your country's VAT tax. Change it after you have imported via
		Joomla back-end: Components > Hikashop > System > Taxes.

		*/
		$config = JFactory::getConfig();
		if(!HIKASHOP_J30){
			$timeoffset = $config->getValue('config.offset');
		} else {
			$timeoffset = $config->get('offset');
		}
		$this->_query(str_replace('1420070400',1420070400-$timeoffset*60*60+date('Z'),"
INSERT IGNORE INTO `#__hikashop_taxation` (`taxation_id`, `zone_namekey`, `category_namekey`, `tax_namekey`, `taxation_published`, `taxation_type`, `taxation_access`, `taxation_cumulative`, `taxation_post_code`, `taxation_date_start`, `taxation_date_end`) VALUES
(0, 'country_Austria_14', 'tax_eservices', 'VAT (AT)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Austria_14', 'tax_eservices', 'VAT (AT)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Austria_14', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Belgium_21', 'tax_eservices', 'VAT (BE)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Belgium_21', 'tax_eservices', 'VAT (BE)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Belgium_21', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Bulgaria_33', 'tax_eservices', 'VAT (BG)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Bulgaria_33', 'tax_eservices', 'VAT (BG)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Bulgaria_33', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Croatia_53', 'tax_eservices', 'VAT (HR)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Croatia_53', 'tax_eservices', 'VAT (HR)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Croatia_53', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Cyprus_55', 'tax_eservices', 'VAT (CY)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Cyprus_55', 'tax_eservices', 'VAT (CY)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Cyprus_55', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Croatia_53', 'tax_eservices', 'VAT (HR)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Croatia_53', 'tax_eservices', 'VAT (HR)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Croatia_53', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Denmark_57', 'tax_eservices', 'VAT (DK)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Denmark_57', 'tax_eservices', 'VAT (DK)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Denmark_57', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Estonia_67', 'tax_eservices', 'VAT (EE)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Estonia_67', 'tax_eservices', 'VAT (EE)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Estonia_67', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Finland_72', 'tax_eservices', 'VAT (FI)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Finland_72', 'tax_eservices', 'VAT (FI)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Finland_72', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_France_73', 'tax_eservices', 'VAT (FR)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_France_73', 'tax_eservices', 'VAT (FR)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_France_73', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Germany_81', 'tax_eservices', 'VAT (DE)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Germany_81', 'tax_eservices', 'VAT (DE)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Germany_81', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Greece_84', 'tax_eservices', 'VAT (GR)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Greece_84', 'tax_eservices', 'VAT (GR)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Greece_84', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Hungary_97', 'tax_eservices', 'VAT (HU)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Hungary_97', 'tax_eservices', 'VAT (HU)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Hungary_97', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Ireland_103', 'tax_eservices', 'VAT (IE)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Ireland_103', 'tax_eservices', 'VAT (IE)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Ireland_103', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Italy_105', 'tax_eservices', 'VAT (IT)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Italy_105', 'tax_eservices', 'VAT (IT)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Italy_105', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Latvia_117', 'tax_eservices', 'VAT (LV)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Latvia_117', 'tax_eservices', 'VAT (LV)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Latvia_117', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Lithuania_123', 'tax_eservices', 'VAT (LT)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Lithuania_123', 'tax_eservices', 'VAT (LT)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Lithuania_123', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Luxembourg_124', 'tax_eservices', 'VAT (LU)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Luxembourg_124', 'tax_eservices', 'VAT (LU)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Luxembourg_124', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Malta_132', 'tax_eservices', 'VAT (MT)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Malta_132', 'tax_eservices', 'VAT (MT)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Malta_132', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Netherlands_150', 'tax_eservices', 'VAT (NL)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Netherlands_150', 'tax_eservices', 'VAT (NL)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Netherlands_150', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Poland_170', 'tax_eservices', 'VAT (PL)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Poland_170', 'tax_eservices', 'VAT (PL)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Poland_170', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Portugal_171', 'tax_eservices', 'VAT (PT)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Portugal_171', 'tax_eservices', 'VAT (PT)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Portugal_171', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Romania_175', 'tax_eservices', 'VAT (RO)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Romania_175', 'tax_eservices', 'VAT (RO)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Romania_175', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Slovakia_189', 'tax_eservices', 'VAT (SK)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Slovakia_189', 'tax_eservices', 'VAT (SK)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Slovakia_189', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Slovenia_190', 'tax_eservices', 'VAT (SI)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Slovenia_190', 'tax_eservices', 'VAT (SI)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Slovenia_190', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Spain_195', 'tax_eservices', 'VAT (ES)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Spain_195', 'tax_eservices', 'VAT (ES)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Spain_195', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Sweden_203', 'tax_eservices', 'VAT (SE)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_Sweden_203', 'tax_eservices', 'VAT (SE)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_Sweden_203', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_United_Kingdom_222', 'tax_eservices', 'VAT (GB)', 1, 'company_without_vat_number', 'all', 0, '', 1420070400, 0),
(0, 'country_United_Kingdom_222', 'tax_eservices', 'VAT (GB)', 1, 'individual', 'all', 0, '', 1420070400, 0),
(0, 'country_United_Kingdom_222', 'tax_eservices', 'VAT Exempt', 1, 'company_with_vat_number', 'all', 0, '', 1420070400, 0);"));

		/*
		* rebuild categories tree

		*/
		$class = hikashop_get('class.category');
		$database = JFactory::getDBO();
		$query = 'SELECT category_left,category_right,category_depth,category_id,category_parent_id FROM #__hikashop_category ORDER BY category_left ASC';
		$database->setQuery($query);
		$root = null;
		$categories = $database->loadObjectList();
		$class->categories = array();
		foreach($categories as $cat){
			$class->categories[$cat->category_parent_id][]=$cat;
			if(empty($cat->category_parent_id)){
				$root = $cat;
			}
		}
		$class->rebuildTree($root,0,1);

		$app = JFactory::getApplication();
		$app->redirect(hikashop_completeLink('taxation',false,true),'The tax rules for Electronic goods & services sales in the European Union have been installed and will be active from the 1st of January 2015. Please note that these taxes apply only to that type of sales. For other types of goods, other rates will apply and you can modify the rates via the "manage tax rates" button of this page. You can find a full list of all the VAT rates in the European Union in <a href="http://ec.europa.eu/taxation_customs/resources/documents/taxation/vat/how_vat_works/rates/vat_rates_en.pdf" target="_blank">this PDF</a>. Finally, you probably need to edit the "Company with VAT number" tax rule for your country and change its rate from "Exempt" to the tax rate of your country as in most European Countries, the VAT has to be charged for everyone in the country even companies with a VAT number which are only exempted from VAT outside for purchases outside their own country.','message');

		return true;
	}

	function _query($query){
		$database = JFactory::getDBO();
		$database->setQuery($query);
		$database->query();
	}
}